<template>
	<div>
		<SpinnerHolder class="loader" v-if="loading" :background="false"></SpinnerHolder>
		<Modal class="modal" v-if="modal" @close="hideSlide()">
			<iframe
				width="100%"
				height="315"
				src="https://www.youtube.com/embed/04ylAFjkjrA"
				frameborder="0"
				allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
				allowfullscreen
			></iframe>
		</Modal>
		<Modal class="modal" v-if="autoSelected" @close="hideSlide()">
			<img class="modal-image" :src="img[0]"/>
		</Modal>
		<div id="root" class="container">
			<div class="home-head">
				<span>Restaurantes</span>
			</div>
			<!-- <CommonHeader :showBackButton="false" title="Directorio"></CommonHeader> -->
			<div class="header">
				<h1 class="title">¡Bienvenido a<br> Beemenu!</h1>
				<img @click="goToOrderOrProfile()" class="profile" src="~@/assets/icons/icon-miperfil.svg" />
			</div>

			<div>
				<div class="left-inner-addon input-container">
					<i class="fa fa-search"></i>
					<input
						type="text"
						placeholder="¿Qué deseas hoy?"
						v-model="searchRest"
					/>
				</div>
			</div>

			<div class="product-gallery">
				<Carousel :items="loadCarousel(img)" :autoplaying="img.length === 1 ? false : true" :autoSelected="true"> </Carousel>
			</div>
			<tabs class="list-content">
				<tab name="restaurantes"  :selected="true">
					<div class="restaurantes" v-for="item in filterRest" :key="item.name">
						<card-list :restaurant="item" :open='item.open' @getInfo='loadInfo()'></card-list>
					</div>
					<div id="the-end"></div>
				</tab>
				<!-- <tab name="express" ></tab> -->
				<tab name="gourmet">
					<div class="restaurantes" v-for="item in filterGourmet" :key="item.name">
						<card-list :restaurant="item" :open='item.open' @getInfo='loadInfo()'></card-list>
					</div>
					<div id="the-end"></div>
				</tab>
			</tabs>
		</div>
	</div>
</template>
<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import tabs from '@/components/Tabs.vue'
import tab from '@/components/Tab1.vue'
import Next from '@/components/Next.vue'
import Thumbnail from '@/components/Thumbnail.vue'
import Carousel from '@/components/Carousel.vue'
import CommonHeader from '@/components/CommonHeader.vue'
import CardList from '@/components/CardList.vue'
import axios from 'axios'
import Modal from '../components/Modal.vue'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import BusinessCategory from '@/models/BusinessCategory'
import DirectoryService from '../services/DirectoryService'
import { BusinessType, InfoBusiness } from '@/models/Menu'
import { MainView } from '@/store/state'
import { getFile } from '@/services/StorageService'

@Component({
	components: {
		tabs,
		tab,
		Next,
		Thumbnail,
		Carousel,
		CommonHeader,
		CardList,
		Modal,
		SpinnerHolder
	}
})
export default class BeeMarket extends Vue {
	autoSelected = false
	loading = false
	modal = false
	searchRest = ''
	by = 7
	count = 0
	infoBusiness: InfoBusiness [] = []
	requestInfo: InfoBusiness [] = []
	tags: BusinessCategory [] | undefined = undefined
	img: Array<string> = [
		'https://firebasestorage.googleapis.com/v0/b/menu-digital-d285e.appspot.com/o/directorio%2Fenvios_a_15_pesos_.png?alt=media&token=ffd85f3e-14b3-4427-ab14-177a4a241f69',
		'https://firebasestorage.googleapis.com/v0/b/menu-digital-d285e.appspot.com/o/directorio%2FHechoMexico(1).png?alt=media&token=5012a297-213e-4e60-b97f-b11694275161',
		'https://firebasestorage.googleapis.com/v0/b/menu-digital-d285e.appspot.com/o/directorio%2FLluvia.png?alt=media&token=b2d07a27-abd6-4cc5-b3bd-ad593924867a',
		'https://firebasestorage.googleapis.com/v0/b/menu-digital-d285e.appspot.com/o/directorio%2Fcard-2.png?alt=media&token=b21c8d01-80fe-4081-b834-d1c84e6151bf',
		'https://firebasestorage.googleapis.com/v0/b/menu-digital-d285e.appspot.com/o/directorio%2Fredes.png?alt=media&token=f8f1ad68-59fe-482b-9652-99d4e5962ac8'
	]

	loadInfo(){
		this.loading = true
	}

	hideSlide() {
		this.modal = false
		this.autoSelected = false
	}

	activator() {
		this.modal = true
	}

	goToOrderOrProfile(){
		this.$store.state.user ? this.$router.push("/profile") : this.$router.push("/login")
	}

	getBusinessCategory(business: InfoBusiness[]): InfoBusiness[] {
		if(this.tags){
			const tagsByFilter: BusinessCategory[] = this.tags?.filter(tag => {
				return tag.name.toLowerCase().includes(this.searchRest.toLowerCase())
			})
			const busByBusCats: InfoBusiness [] = this.requestInfo.filter(bus => {
				const idTags = tagsByFilter.map(tag => tag.id)
				return bus.directory?.businessCategory.some(bu => idTags.indexOf(bu) >= 0)	
			})
			busByBusCats 
				? business = business.concat(busByBusCats)
				: null
			//Elimina la duplicidad en la concatenacion
			business = [... new Map(business.map(bus => [bus['id'], bus])).values()]
		}
		return business
	}

	scroll() {
        const scrolledTo = document.querySelector('#the-end')
        if (scrolledTo && this.isScrolledIntoView(scrolledTo) && this.count > 0 && this.count < this.requestInfo.length) {
			this.infoBusiness.push(...this.requestInfo.slice(this.count, (this.count + this.by)))
			this.count += this.by
        }
    }

    isScrolledIntoView(el: Element) {
        const rect = el.getBoundingClientRect()
        const elemTop = rect.top
        const elemBottom = rect.bottom
        const isVisible = elemTop < window.innerHeight && elemBottom >= 0
        return isVisible
    }

	mounted() {
        if(document.querySelector('.app-container') != null){
            document.querySelector('.app-container')?.addEventListener('scroll', this.scroll);
        }
    }

	get filterRest(){
		const business: InfoBusiness[] = this.infoBusiness.filter(bus => {
			return bus.name.toLowerCase().includes(this.searchRest.toLowerCase()) 
			&& (bus.directory?.businessType === BusinessType.RESTAURANTS
			|| bus.directory?.businessType === BusinessType.GOURMET)
		})
		if(this.searchRest == ''){
			return business
		}else{
			return this.getBusinessCategory(business)
		}
	}

	get filterGourmet(){
		const business: InfoBusiness[] = this.requestInfo.filter(bus => {
			return bus.name.toLowerCase().includes(this.searchRest.toLowerCase()) 
			&& bus.directory?.businessType === BusinessType.GOURMET
		})
		return business
	}

	get filterExpress(){
		const business: InfoBusiness[] = this.requestInfo.filter(bus => {
			return bus.name.toLowerCase().includes(this.searchRest.toLowerCase()) 
			&& bus.directory?.businessType === BusinessType.EXPRESS
		})
		return business
	}
	

	async getData(){
		try {
			const config = {
				params: {
					delivery: true,
					sameDay: true,
					city: 'Cancún',
					state: 'Quintana Roo'
				}
			}
			const response = await axios.get(`${process.env.VUE_APP_CATALOG}`, config)
			this.requestInfo = response.data
			this.requestInfo.forEach(async data => {
				data.logo = await getFile(data.logo)
			});
			this.infoBusiness = this.requestInfo.slice(0, this.by)
			this.count = this.by
			this.loading = false
		} catch (err) {
			console.log(err)
		}
		this.$analytics.logEvent('view_item_list', {
			item_list_name: 'Directory',
		})
		this.autoSelected = true
	}

	async created(){
		this.loading = true
		await this.$store.dispatch('setMainView', MainView.DIRECTORY)
		this.tags = await DirectoryService.getBusinessTags()
		this.getData()
		this.$store.dispatch('changeCurrency', 'MXN')
		this.$store.dispatch('changeLanguage', 'spanish')
	}

	loadCarousel(photosURL: Array<string>) {
		const items = photosURL.map(i => ({ url: i }))
		return items
	}
}
</script>
<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}
.home-head {
	background-color: black;
	padding: 15px;
	display: flex;
	flex-direction: row;
	color: #ffffff;
	justify-content: space-between;
	align-items: center;
	span {
		margin-left: 20px;
		font-size: 14px;
		margin: 0 auto;
	}
}

.header{
	display: flex;
    justify-content: space-around;
	.title {
		color: #000000;
		font-family: 'Poppins', sans-serif;
		font-style: normal;
		font-weight: 600;
		font-size: 21px;
		line-height: 27px;
	}
	img{
		width: 50px;
		height: 50px;
		border-radius: 50%;
		background-color: #f8c83b;
		margin-top: 4%;
		// cursor: pointer;
		// background: transparent;
		// border: none;
		// color: #000000;
		// font-weight: 600;
		// font-size: 9px;
		// line-height: 13px;
		// font-family: 'Poppins', sans-serif;
		// background-color: ;
		// .icon-circle {
		// 	color: #401EC2;
		// 	font-size: 2em;
		// 	border: 2px solid;
		// 	padding: 0.5em;
		// 	border-radius: 50%;
		// }
	}
}

.list-content{
	padding: 1em;
}
.product-gallery {
	height: 30vh;
	background-color: white;
	position: relative;
	margin: 1em;
}

.modal {
	::v-deep .modal-container {
		width: 90%;
		padding: 10px 10px;

		.modal-image {
			width: 100%;
			height: 100%;
			object-fit: contain;
		}
	}
}

.next {
	background-color: #FDDB9B !important;
	padding: 0.1em !important;
}
.left-inner-addon {
	position: relative;
    padding: 0.5em 1.5em;

}
.left-inner-addon input {
	padding: 17px 0 17px 35px !important;
	background: #F5F5F8;
	border-radius: 5px;
}
.left-inner-addon i {
	position: absolute;
	padding: 17px 12px;
	pointer-events: none;
	color: #757070;
}
input {
	width: 100%;
	padding: 1em !important;
	margin: 0em !important;
	box-sizing: border-box;
	border-radius: 4px;
	border: 1px solid #e0e0e0;
}
input::-webkit-input-placeholder {
	color: rgba(117, 112, 112, 1);
	font-size: 1.2em;
}
</style>
